//var app = angular.module('Anamnesi', ['ui.check','ui.bootstrap','chieffancypants.loadingBar', 'ngAnimate'])
var app = angular.module('Anamnesi', ['ui.bootstrap','chieffancypants.loadingBar', 'ngAnimate'])
    .config(function($locationProvider,$httpProvider,cfpLoadingBarProvider) {
        $locationProvider.html5Mode(true);
        $locationProvider.html5Mode(true).hashPrefix('!');
        //Reset headers to avoid OPTIONS request (aka preflight)
        $httpProvider.defaults.headers.common = {};
        $httpProvider.defaults.headers.post = {};
        $httpProvider.defaults.headers.put = {};
        $httpProvider.defaults.headers.patch = {};
        cfpLoadingBarProvider.includeSpinner = true;

    });


app.directive('modal', function () {
    return {
        template: '<div class="modal fade">' +
        '<div class="modal-dialog" id="dialogo" style="width: {{docmodalwidth}}px; padding: 20px">' +
        '<div class="modal-content">' +
        '<div class="modal-header" style="padding: 10px">' +
        '<button class="btn btn-primary pull-right" style="width: 80px" ng-click="fun_submit()">OK</button>' +
        '<button class="btn btn-warning pull-right" ng-click="closePopUp()">Cancel</button>' +
        '<button class="btn btn-sm btn-warning pull-left" ng-click="puliscifirma()">Pulisci</button>' +
        '<h4 class="modal-title" style="text-align: center">{{ title }}</h4>' +
        '</div>' +
        '<div class="modal-body" style="height: 230px; padding: 5px" ng-transclude></div>' +
        '<div class="modal-footer" style="padding: 5px">' +
        '</div>' +
        '</div>' +
        '</div>' +
        '</div>',
        restrict: 'E',
        transclude: true,
        replace:true,
        scope:true,
        link: function postLink(scope, element, attrs) {
            scope.title = attrs.title;

            scope.$watch(attrs.visible, function(value){
                if(value == true)
                    $(element).modal('show');
                else
                    $(element).modal('hide');
            });

            $(element).on('shown.bs.modal', function(){
                scope.$apply(function(){
                    scope.$parent[attrs.visible] = true;
                });
            });

            $(element).on('hidden.bs.modal', function(){
                scope.$apply(function(){
                    scope.$parent[attrs.visible] = false;
                });
            });
        }
    };
});

app.controller('AnamnesiCtrl', function($scope, $http, $location, $sce, $anchorScroll,$modal){
    $scope.listaPaz =[];
    $scope.Domande=[];
    $scope.domandePrincipali =[];
    $scope.domandeSecondarie=[];
    $scope.labelmsg="";
    $scope.labelmessaggio="";
    $scope.labeldomanda="";


    $scope.datedetected=function(){
        if(!Modernizr.inputtypes.date) {
            $scope.supportodate = false
        }else{
            $scope.supportodate = true
        }
    };

    $scope.open = function($event) {
        $event.preventDefault();
        $event.stopPropagation();

        $scope.opened = true;
    };

    $scope.init = function () {
        $scope.islast=false;
        $scope.showModal = false;
        $scope.datedetected();
        $scope.btfinedisabled=true;
        $scope.showmsgsecondario=false;
        $scope.btavdisabled=false;
        $scope.btinddisabled=true;
        $scope.btannulladisabled=false;
        $scope.showlabelmessaggio=false;
        $scope.leftMButtonDown = false;

        $scope.ipchiamante=$location.search()["ip"];
        $scope.doc=$location.search()["doc"];
        $scope.curIdPaz= $location.search()["id"];
        $scope.fi=$location.search()["fi"];
        if (!$scope.fi){
            $scope.fi=0;
        }

        if ($scope.curIdPaz){
            $scope.loadAnamnesi($scope.curIdPaz);
        }else {
            $http.post('http://'+$scope.ipchiamante+':9000/anamnesi/lista.json')
                .success(function(response) {
                    $scope.listaPaz =   response ;
                    if ($scope.listaPaz) {
                        if ($scope.listaPaz.length==0) {
                            $scope.showlabelmessaggio=true;
                            $scope.btannulladisabled=true;
                            $scope.labelmessaggio=$sce.trustAsHtml("Nessuna lista pazienti rilevata");
                            $scope.labeldomanda="";
                        } else{
                            if ($scope.listaPaz.length == 1) {
                                $scope.curIdPaz = $scope.listaPaz[0]["codice_cliente"];
                                $scope.paziente = $scope.listaPaz[0]["paziente"]
                                $scope.loadAnamnesi($scope.curIdPaz);
                            } else {
                                $scope.showdivListaAn=true;
                                $scope.labelmsg="Lista Anagrafiche";
                                $scope.labeldomanda="";
                                $scope.showdivPrincipale=false;
                            }
                        }
                    }else{
                        $scope.showdivListaAn=true;
                        $scope.showlabelmessaggio=true;
                        $scope.labelmessaggio=$sce.trustAsHtml("Nessuna lista pazienti rilevata");
                        $scope.btannulladisabled=true;
                        $scope.labeldomanda="";
                    }
                }).error(function(data, status, repsonse, header) {
                    $scope.showlabelmessaggio=true;
                        $scope.labelmessaggio=$sce.trustAsHtml("Errore nel caricamento della lista pazienti");

                    $scope.showmsgsecondario=true;
                    var msg2 = "Verificare che il server dati di Horizon sia raggiungibile";
                    if ($scope.ipchiamante) {
                        msg2 = msg2 + " o se stai utilizzando Internet Explorer 11 controlla le impostazioni sicurezza aggiungendo tra i siti attendibili l 'indirizzo <font style='color: #cd0a0a'> http://"+$scope.ipchiamante+"</font>";
                    }
                    $scope.labelmessaggiosecondario=$sce.trustAsHtml(msg2);
                    $scope.labeldomanda="";
                });

        }
    }

    function getIndexOf(arr, val, prop) {
        var l = arr.length,
            k = 0;
        for (k = 0; k < l; k = k + 1) {
            if (arr[k][prop] === val) {
                return k;
            }
        }
        return -1;
    }

    $scope.apriAn= function(id){
        if ($scope.curIdPaz != -400){
            //carico l'anamnesi del paziente selezionato
            idarr=getIndexOf($scope.listaPaz, id, "codice_cliente");
            if (idarr!=-1) {
                $scope.curIdPaz = id;
                $scope.paziente = $scope.listaPaz[idarr]["paziente"];
                $scope.loadAnamnesi(id);
            }
        }else{
            $scope.curIdPaz = -1;
        }
    }
    $scope.popoladiv=function(){

        if ($scope.intro){
            $scope.showdivPrincipale=false;
            $scope.showdivIntro=true;
            $scope.showlabelmessaggio=true;
            $scope.labelmessaggio=$sce.trustAsHtml($scope.intro);
        } else {
            $scope.showdivPrincipale=true;
            $scope.showlabelmessaggio=false;
            $scope.showdivIntro=false;
            $scope.labelmessaggio="";

            $scope.curdomanda =$scope.Domande["anamnesi"][$scope.curid];
            $scope.selection=$scope.curdomanda.tipo;
            $scope.items = $scope.curdomanda.valori;
            if ($scope.selection=="2"){
                inizializzacombo(1);
            }

            if ($scope.selection==6){
                $scope.initfirma();

                if ((!$scope.curdomanda.risposta)||($scope.curdomanda.risposta=="")){
                    $scope.btfinedisabled=true;
                }else{
                    $scope.btfinedisabled=false;
                }
            }

            if (($scope.curdomanda.domandacollegata!==-1)& ($scope.curdomanda.tipo!="6")){
                $scope.arrsecondarioindex=getIndexOf($scope.domandeSecondarie,$scope.curdomanda.domandacollegata,"id");
                $scope.curdomandaSecondaria =$scope.domandeSecondarie[$scope.arrsecondarioindex];
                $scope.showdivSecondario=true;
                $scope.selectionsecondaria=$scope.curdomandaSecondaria.tipo;
                $scope.itemssecondari = $scope.curdomandaSecondaria.valori;
                if ($scope.selectionsecondaria=="2s"){
                    inizializzacombo(2);
                }
            }else {
                $scope.curdomandaSecondaria=null
                $scope.showdivSecondario=false;
                $scope.selectionsecondaria="";
            };
        };
    }

    $scope.goHome=function(){
        changeLocation('/index.html?ip=' + $scope.ipchiamante, true);
    }

    $scope.iniziaAnamnesi = function (){
        $scope.showdivIntro=false;
        $scope.intro=null;
        $scope.showdivPrincipale=true;
        $scope.showlabelmessaggio=false;
        $scope.labelmessaggio="";
    }

    function inizializzacombo(sec){
        if (sec==1){
            angular.forEach($scope.items, function(p) {
                p.id= p.name;
            });

            v={name:' ',id:' '};
            $scope.items.unshift(v);
            $scope.curdomanda.risposta=$scope.items[0].id;
        }else{
            angular.forEach($scope.itemssecondari, function(p) {
                p.id= p.name;
            });

            v={name:' ',id:' '};
            $scope.itemssecondari.unshift(v);
            $scope.curdomandaSecondaria.risposta=$scope.itemssecondari[0].id;

        }
    }

    $scope.loadAnamnesi = function(ccliente) {
        $scope.curid =0;
        $scope.Domande=[];
        $scope.domandePrincipali=[];
        $scope.domandeSecondarie=[];

        $scope.showdivListaAn=false;
        $http.get('http://'+$scope.ipchiamante+':9000/anamnesi/view.json?codice_cliente='+ccliente) //la chiamata json dovrà avere il codice_cliente come parametro
            .success(function(response) {
                $scope.Domande =   response ;
                $scope.paziente=$scope.Domande["paziente"]
                $scope.curdomanda =$scope.Domande["anamnesi"][0];

                $scope.intro=$scope.Domande["intro"];

                //Funzione che dall'array principale crea un secondo array con le domande collegate cercandole per il campo id
                angular.forEach($scope.Domande["anamnesi"], function(domanda) {
                    if (domanda.tipo!="6"){
                        //if (domanda.tipo=="1" ||domanda.tipo=="TcxDBCheckBox"){
                        //    if (domanda.risposta!="1"){
                        //        domanda.risposta="0";
                        //    }
                        //}
                        if (domanda.domandacollegata!=-1){
                            $scope.arrindex=getIndexOf($scope.Domande["anamnesi"],domanda.domandacollegata,"id");
                            $scope.Domande["anamnesi"][$scope.arrindex].tipo=$scope.Domande["anamnesi"][$scope.arrindex].tipo+'s';
                            $scope.domandeSecondarie.push( $scope.Domande["anamnesi"][$scope.arrindex]);
                            $scope.Domande["anamnesi"].splice($scope.arrindex, 1 );
                        }
                    }
                });
                $scope.labelmsg=$scope.paziente;
                $scope.labeldomanda= ($scope.curid+1) + ' di ' + $scope.Domande["anamnesi"].length;

                $scope.popoladiv();

                $scope.canvasbianco=    document.getElementById("blank");
                $scope.canvas=    document.getElementById("canvas");
                $scope.canvasContext= $scope.canvas.getContext("2d");

                var sizedWindowWidth = window.innerWidth;

                $scope.docmodalwidth=sizedWindowWidth;

                $scope.canvas.height = 150;
                $scope.canvas.width = sizedWindowWidth -50;
                $scope.canvasbianco.height = 150;
                $scope.canvasbianco.width = sizedWindowWidth -50;


                if($scope.canvasContext) {
                    $scope.canvasContext.canvas.width = $scope.canvas.width;
                    $scope.canvasContext.canvas.height = 150;
                }
            }).error(function(data, status) {
                $scope.showlabelmessaggio=true;
                $scope.labelmessaggio=$sce.trustAsHtml("Errore nel caricamento dell'anamnesi");
                $scope.labeldomanda="";
                alert( "failure message: " + JSON.stringify({data: response}));
            });
    };

    $scope.gotoAnchor = function(x) {
        var newHash = x;
        if ($location.hash() !== newHash) {
            // set the $location.hash to `newHash` and
            // $anchorScroll will automatically scroll to it
            $location.hash(x);
        } else {
            // call $anchorScroll() explicitly,
            // since $location.hash hasn't changed
            $anchorScroll();
        }
    };

    var changeLocation = function(url, forceReload) {
        $scope = $scope || angular.element(document).scope();
        if(forceReload || $scope.$$phase) {
            window.location = url;
        }
        else {
            //only use this if you want to replace the history stack
            //$location.path(url).replace();

            //this this if you want to change the URL and add it to the history stack
            $location.path(url);
            $scope.$apply();
        }
    };

    $scope.$watch("curid", function(newValue, oldValue) {
        if (newValue != oldValue) {
            if ($scope.curdomanda){
                $scope.$evalAsync( function() {
                    $scope.gotoAnchor('top'+$scope.curdomanda.tipo);
                });
            }
        }
    });

    $scope.avanti = function () {
      $scope.curid += 1;
      $scope.labelmsg=$scope.paziente;
      $scope.labeldomanda= ($scope.curid+1) + ' di ' + $scope.Domande["anamnesi"].length;
      if($scope.curid ==$scope.Domande["anamnesi"].length-1) {
        $scope.btavdisabled=true;
        $scope.islast=true;
        $scope.btfinedisabled=false;
      }else{
        $scope.islast=false;
        $scope.btavdisabled=false;
        $scope.btfinedisabled=true;
      }
        $scope.popoladiv();
        $scope.btinddisabled=false;

    }
    $scope.indietro = function() {
        $scope.curid += -1;
        $scope.labelmsg=$scope.paziente;
        $scope.labeldomanda= ($scope.curid+1) + ' di ' + $scope.Domande["anamnesi"].length;
        if($scope.curid ==0) {
            $scope.btinddisabled=true;
        }else {
            $scope.btinddisabled=false;
        }
        $scope.popoladiv();
        $scope.btavdisabled=false;
        $scope.btfinedisabled=true;
        $scope.islast=false;
    }

    $scope.fine = function() {
        $scope.btannulladisabled=true;
        $scope.risposte=$scope.Domande["anamnesi"].concat($scope.domandeSecondarie);

        $http.post('http://'+$scope.ipchiamante+':9000/anamnesi/view.json?codice_cliente='+ $scope.curIdPaz,$scope.risposte) //la chiamata json dovrà avere il codice_cliente come parametro
            .success(function(response) {
                if ($scope.doc=="true"){
                    alert( "Grazie per aver completato l'inserimento dell'anamnesi. Si prega di continuare con la compilazione dei documenti");
                    changeLocation('http://'+$scope.ipchiamante+':9000/documenti?id=' + $scope.curIdPaz+'&fi='+$scope.fi, true);
                }else{
                    $scope.showdivListaAn=false;
                    $scope.showdivPrincipale=false;
                    $scope.showdivSecondario=false;
                    $scope.curid =0;
                    $scope.Domande=[];
                    $scope.domandePrincipali=[];
                    $scope.domandeSecondarie=[];
                    $scope.labelmsg="Anamnesi Completata";
                    $scope.showlabelmessaggio=true;
                    $scope.labelmessaggio = $sce.trustAsHtml("Grazie per aver completato l'anamnesi. Si prega di rivolgersi al personale di studio");
                    $scope.labeldomanda="";
                    $scope.btinddisabled=true;
                }

            }).error(function(data, status) {
                $scope.showlabelmessaggio=true;
                $scope.labelmessaggio=$sce.trustAsHtml(response + "Errore nel salvataggio dell'anamnesi");
                $scope.labeldomanda="";
                alert( "failure message: " + JSON.stringify({data: response}));
            });

    }

    $scope.annullaanamnesi = function() {
        var retVal = confirm("Vuoi annullare l'introduzione dati dell'anamnesi?");
        if (retVal == true) {
            $http.delete('http://'+$scope.ipchiamante+':9000/anamnesi/view.json?codice_cliente=' + $scope.curIdPaz) //la chiamata json dovrà avere il codice_cliente come parametro
                .success(function (response) {
                    $scope.showdivListaAn = false;
                    $scope.showdivPrincipale = false;
                    $scope.showdivSecondario = false;
                    $scope.curid = 0;
                    $scope.Domande = [];
                    $scope.domandePrincipali = [];
                    $scope.domandeSecondarie = [];
                    $scope.labelmsg = "Anamnesi Annullata";
                    $scope.showlabelmessaggio=true;
                    $scope.labelmessaggio = $sce.trustAsHtml("Anamnesi Annullata. Si prega di rivolgersi al personale di studio");
                    $scope.labeldomanda = "";
                    $scope.showdivIntro=false;
                    $scope.btavdisabled=true;
                    $scope.btinddisabled=true;
                    $scope.btannulladisabled=true;
                }).error(function (data, status) {
                    $scope.showlabelmessaggio=true;
                    $scope.labelmessaggio = $sce.trustAsHtml("Errore nell'annullamento dell'anamnesi");
                    $scope.labeldomanda = "";
                    alert("failure message: " + JSON.stringify({data: response}));
                });
        }
    }
    $scope.elimina = function(badge) {
        iddel=getIndexOf($scope.listaPaz, badge, "codice_cliente");
        if (iddel!=-1) {
            $scope.curIdPaz="-400";
            var retVal = confirm("Vuoi annullare l'introduzione dati dell'anamnesi?");
            if (retVal == true) {
                $http.delete('http://'+$scope.ipchiamante+':9000/anamnesi/view.json?codice_cliente=' + badge) //la chiamata json dovrà avere il codice_cliente come parametro
                    .success(function (response) {

                        $scope.listaPaz.splice(iddel,1);
                        $scope.init();

                }).error(function (data, status) {
                    alert("failure message: " + JSON.stringify("Errore nell'eliminazione dell'anamnesi"));
                });
            }else{
                return;
            }
        }
    }

    $scope.puliscifirma = function(){
        $scope.initfirma();

        $scope.imgData = "";
        $scope.canvasContext.clearRect ( 0 , 0 , $scope.canvas.width, $scope.canvas.height );
        $scope.curdomanda.risposta="";
        $scope.btfinedisabled=true;
    }

    $scope.initfirma = function(){
        //$scope.showModal = !$scope.showModal;
        //$scope.docmodal=    document.getElementById("dialogo");

        var isTouchDevice = !!("ontouchstart" in window);
        if (isTouchDevice) {
            var drawer = {
                isDrawing: false,
                touchstart: function(coors){
                    $scope.canvasContext.beginPath();
                    $scope.canvasContext.moveTo(coors.x, coors.y);
                    $scope.canvasContext.arc(coors.x, coors.y, 0.5, 0, 2 * Math.PI);
                    $scope.canvasContext.stroke();
                    this.isDrawing = true;
                },
                touchmove: function(coors){
                    if (this.isDrawing) {
                        $scope.canvasContext.lineTo(coors.x, coors.y);
                        $scope.canvasContext.stroke();
                    }
                },
                touchend: function(coors){
                    if (this.isDrawing) {
                        this.touchmove(coors);
                        $scope.canvasContext.closePath();
                        this.isDrawing = false;
                    }
                }
            };
            // create a function to pass touch events and coordinates to drawer
            function draw(event){
                // get the touch coordinates
                var coors = {
                   x : event.targetTouches[0].pageX - $(event.target).offset().left,
                   y : event.targetTouches[0].pageY - $(event.target).offset().top
                };
                // pass the coordinates to the appropriate handler
                drawer[event.type](coors);
            }

            $scope.canvas.addEventListener('touchstart',draw, false);
            $scope.canvas.addEventListener('touchmove',draw, false);
            $scope.canvas.addEventListener('touchend',draw, false);

            // prevent elastic scrolling
            document.body.addEventListener('touchmove',function(event){
                event.preventDefault();
            },false);

        }else {
            $scope.canvas.onmousedown = function (e) {
                if (e.which === 1) {
                    $scope.ismove=false;
                    $scope.leftMButtonDown = true;
                    $scope.canvasContext.fillStyle = "#000";
                    var x = e.pageX - $(e.target).offset().left;
                    var y = e.pageY - $(e.target).offset().top;
                    $scope.canvasContext.beginPath();
                    $scope.canvasContext.moveTo(x, y);
                    $scope.canvasContext.stroke();
                }
                e.preventDefault();
                return false;
            };

            $scope.canvas.onmouseup = function (e) {
                if ($scope.leftMButtonDown && e.which == 1) {
                    if (!$scope.ismove){
                        var x = e.pageX - $(e.target).offset().left;
                        var y = e.pageY - $(e.target).offset().top;
                        $scope.canvasContext.arc(x, y, 1, 0, 2 * Math.PI);
                        $scope.canvasContext.arc(x, y, 1, 1, 2 * Math.PI);
                        $scope.canvasContext.arc(x, y, 1, 2, 2 * Math.PI);
                        $scope.canvasContext.stroke();
                    }
                    $scope.leftMButtonDown = false;
                    $scope.canvasContext.closePath();
                }
                e.preventDefault();
                return false;
            };

        // draw a line from the last point to this one
            $scope.canvas.onmousemove = function (e) {
                if ($scope.leftMButtonDown == true) {
                    $scope.ismove=true;
                    $scope.canvasContext.fillStyle = "#000";
                    var x = e.pageX - $(e.target).offset().left;
                    var y = e.pageY - $(e.target).offset().top;
                    $scope.canvasContext.lineTo(x, y);
                    $scope.canvasContext.stroke();
                }
                e.preventDefault();
                return false;
            };
        }
    }

    $scope.fun_submit=function() {
        if($scope.canvas.toDataURL() == $scope.canvasbianco.toDataURL()){
            alert('Firma non inserita');
        }else{
            $scope.imgData = $scope.canvas.toDataURL();
            $scope.curdomanda.risposta=$scope.imgData;
            $scope.closePopUp();
            $scope.fine();
        }
    }
    $scope.closePopUp=function() {
        if ((!$scope.imgData)||($scope.imgData=="")){
            $scope.btfinedisabled=true;
        }else{
            $scope.btfinedisabled=false;
        }

        //$scope.canvasContext.clearRect ( 0 , 0 , $scope.canvas.width, $scope.canvas.height );
        //$scope.showModal = false;
    }
});




